#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define REP(i, N) for(int (i)=0; (i)<(N); (i)++)
#define ll long long
#define mp make_pair
#define pb push_back
bool ok[111][111];
char bd[111][111];
char prog[11];
int d[4][2] = {{-1,0},{0,1},{1,0},{0, -1}};
int visited[111][111][11][4];
int reached[111][111][11][4];
int h,w,l;

bool run(int r, int c, int in, int dir) {
	if(visited[r][c][in][dir]) {
		return true;
	}
	
	visited[r][c][in][dir] = true;
	bool res = dir == 0 ? true : false;
	if(prog[in] == 'S') {
		int fr = r-d[dir][0], fc = c-d[dir][1];
		if(fr >= h||fc>=w||fr<0||fc<0||bd[fr][fc]=='X') {
			fr = r; fc = c;
		}
		int nrr = fr+d[dir][0], ncc = c+d[dir][1];
		if(nrr >= h || ncc >=w||nrr<0||ncc>0||bd[nrr][ncc] == 'X') {
			nrr = r; ncc = c;
		}
		if(nrr != r && ncc != c) {
//			return res;
		}
		res |= run(fr, fc, (in+l-1)%l, dir);
	} else if(prog[in] == 'L') {
		res |= run(r, c, (in+l-1)%l, (dir+1)%4);
	} else if(prog[in] == 'R') {
		res |= run(r, c, (in+l-1)%l, (dir+3)%4);
	}
	return res;
}

int main() {
	while(scanf("%d %d", &h, &w) == 2) {
		REP(i, h) REP(j, w) ok[i][j] = false;
		REP(i, h) scanf("%s", bd[i]);
		scanf("%d", &l);
		scanf("%s", prog);
		memset(visited, 0, sizeof(visited));
		REP(i, h) REP(j, w) if(bd[i][j] == 'E') {
			REP(k, l)
				if(prog[k] == 'S') {
					REP(dd, 4) {
						printf("starting run from %d %d %d %d\n", i, j, k, dd);
						run(i, j, k, dd);
					}
				}
		}
		int total=0, right = 0;
		REP(i, h) REP(j, w) {
			if(bd[i][j] == '.' || bd[i][j] == 'E') {
				if(visited[i][j][0][0]) {
					right++;
					printf("%d %d\n", i, j);
				}
				total++;
			}
		}
		if(total == right) printf("OK\n");
		else printf("%d\n", right);
	}
	return 0;
}
